import 'dart:convert';
import 'dart:io';

import 'package:crp_core/auth/provider/jwt/JwtToken.dart';
import 'package:crp_core/auth/provider/oauth/OAuthToken.dart';
import 'package:crp_core/core/exception/AppException.dart';
import 'package:crp_core/core/http/AppHttpResponse.dart';
import 'package:crp_core/core/model/AuthToken.dart';
import 'package:crp_core/core/provider/AuthProvider.dart';
import 'package:crp_core/env/EnvConfig.dart';
import 'package:http/http.dart' as http;

class OAuthProvider extends AuthProvider<OAuthToken> {
  String _apiUrl;

  OAuthProvider(this._apiUrl);

  @override
  Future<AuthToken> auth(credentials, {Map<String, String> header}) async {
    /*var response = await http.post("${Env.instance.config.authApiUrl}$_apiUrl",
        body: credentials);
    if (response.statusCode == 200) {
      return ApiResponse.success(
          response.statusCode, JwtToken.fromJson(jsonDecode(response.body)));
    } else {
      return ApiResponse.failure(response.statusCode, null);
    }*/

    try {
      var response = await http
          .post("${Env.instance.config.authApiUrl}$_apiUrl", body: credentials, headers: header);
      var body = returnResponse(
          AppHttpResponse(code: response.statusCode, body: response.body));
      return JwtToken.fromJson(jsonDecode(body));
    } on SocketException {
      throw FetchDataException('Sem conexão à Internet');
    }
  }
}
