import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

class NavigationBloc {
  static final NavigationBloc instance = NavigationBloc._();

  NavigationBloc._();

  final GlobalKey<NavigatorState> navigatorKey =
      new GlobalKey<NavigatorState>();

  Future<dynamic> navigateTo(String routeName) {
    return navigatorKey.currentState.pushNamed(routeName);
  }

  Future<dynamic> navigateToRemoveUntil(String routeName) {
    return navigatorKey.currentState.pushNamedAndRemoveUntil(routeName, (Route<dynamic> route) => false);
  }

  Future<dynamic> navigateLogout() {
      return navigateToRemoveUntil("/login");
  }

  bool goBack() {
    return navigatorKey.currentState.pop();
  }
}
