class AppException implements Exception {
  final String _message;
  final String _prefix;
  dynamic data;

  AppException(this._message, this._prefix, {this.data});

  String toString() {
    return "$_prefix$_message";
  }

  String get message => _message;
}

class FetchDataException extends AppException {
  FetchDataException([String message, dynamic data])
      : super(message, "Falha na comunicação: ", data: data);
}

class BadRequestException extends AppException {
  BadRequestException([message, dynamic data]) : super(message, "Requisição inválida: ", data: data);
}

class UnauthorizedException extends AppException {
  UnauthorizedException([message, dynamic data]) : super(message, "Não Autorizado: ", data: data);
}

class InvalidInputException extends AppException {
  InvalidInputException([String message]) : super(message, "");
}

class NotFoundException extends AppException {
  NotFoundException([String message]) : super(message, "");
}

class TokenStorageException extends AppException{
  TokenStorageException([String message]) : super(message, "Token: ");
}

class UserStorageException extends AppException{
  UserStorageException([String message]) : super(message, "Token: ");
}
