import 'package:crp_core/core/exception/AppException.dart';

class AppHttpResponse {
  final int code;
  final dynamic body;

  AppHttpResponse({this.code, this.body});
}

dynamic returnResponse(AppHttpResponse response) {
  switch (response.code) {
    case 200:
    case 201:
      return response.body;
    case 400:
      throw BadRequestException(response.body.toString(), response.body);
    case 401:
    case 403:
      throw UnauthorizedException(response.body.toString(), response.body);
    case 404:
      throw NotFoundException(response.body.toString());
    case 500:
    default:
      throw FetchDataException(
          'Ocorreu um error ao realizar a conexão, código: ${response.code}');
  }
}
