import 'package:crp_core/core/bloc/NavigationBloc.dart';
import 'package:crp_core/core/model/AuthToken.dart';
import 'package:crp_core/core/storage/AuthTokenStorage.dart';
import 'package:dio/dio.dart';

class TokenInterceptor extends Interceptor {
  @override
  Future onRequest(RequestOptions options) async {
    if(options.extra.containsKey("token") && options.extra["token"]){
      AuthToken token = await AuthTokenStorage.instance.getAuthToken();
      if (token == null) {
        NavigationBloc.instance.navigateLogout();
        throw DioError(error: 'Token não encontrado!');
      }
      String typeToken = token.tokenType == null ? 'Bearer' : token.tokenType;
      options.headers['Authorization'] = "$typeToken ${token.token}";
    }
    super.onRequest(options);
  }
}
