import 'package:crp_core/core/exception/AppException.dart';
import 'package:crp_core/core/model/AuthToken.dart';
import 'package:crp_core/core/provider/AuthProvider.dart';
import 'package:crp_core/core/storage/AuthTokenStorage.dart';

class AuthRepository<T extends AuthToken> {
  AuthProvider _authProvider;

  AuthRepository(this._authProvider);

  Future<T> auth(Map<String, String> credentials, { Map<String, String> header }) async {
    dynamic authToken = await _authProvider.auth(credentials, header: header);
    if (authToken != null) {
      try {
        await AuthTokenStorage.instance.putAuthToken<T>(authToken);
        return authToken;
      } on TokenStorageException catch (e) {
        throw e;
      }
    }
    return null;
  }
}
