import 'package:crp_core/core/bloc/Bloc.dart';
import 'package:crp_core/core/bloc/BlocController.dart';
import 'package:crp_core/core/model/AppResponse.dart';
import 'package:crp_core/core/model/Entity.dart';
import 'package:crp_core/default/repository/DefaultRepository.dart';

class DefaultBloc extends Bloc {
  final dynamic _repository;
  final _controller = BlocController<AppResponse<List<dynamic>>>(initalData: null);
  final _resourceName;

  DefaultBloc(this._resourceName, this._repository);

  Stream<AppResponse<List<dynamic>>> get streamOut => _controller.stream;

  fetchAll() async {
    _controller.add(AppResponse.loading('Carregando $_resourceName'));
    try {
      List<dynamic> list = await _repository.fetchAll();
      _controller.add(AppResponse.completed(list));
    } catch (e) {
      _controller.add(AppResponse.error(e.toString()));
    }
  }

  @override
  void dispose() {
    _controller.dispose();
  }
}
