import 'package:crp_core/core/model/Entity.dart';
import 'package:crp_core/core/provider/Provider.dart';
import 'package:crp_core/core/repository/Repository.dart';
import 'package:crp_core/default/repository/JsonEntityCreator.dart';

class DefaultRepository<T extends Entity> extends Repository {
  JsonEntityCreator<T> _jsonEntityCreator;
  dynamic _provider;

  DefaultRepository(this._jsonEntityCreator, this._provider);

  @override
  Entity fromMap(Map<String, dynamic> json) {
    return  _jsonEntityCreator(json);
  }

  @override
  Provider<T> getApiProvider() {
    return _provider;
  }
}
