import 'dart:convert';

class Util {
  static checkApiUrl(String url) {
    if (!url.endsWith("/")) {
      url = url + "/";
    }
    return url;
  }

  static Map<String, dynamic> decodeClaims(String token){
    final parts = token.split('.');

    if (parts.length >= 3) {
      final payload = Util.decodeBase64(parts[1]);
      final payloadMap = jsonDecode(payload);
      if (payloadMap is Map<String, dynamic>) {
        return payloadMap;
      }
    }
    return null;
  }

  static String decodeBase64(String str) {
    String output = str.replaceAll('-', '+').replaceAll('_', '/');

    switch (output.length % 4) {
      case 0:
        break;
      case 2:
        output += '==';
        break;
      case 3:
        output += '=';
        break;
      default:
        throw Exception('Illegal base64url string!"');
    }

    return utf8.decode(base64Url.decode(output));
  }
}
